# Source Generated with Decompyle++
# File: in.pyo (Python 2.5)

import dns.name as dns
import dns.ipv6 as dns
import dns.ipv4 as dns
ipv4_reverse_domain = dns.name.from_text('in-addr.arpa.')
ipv6_reverse_domain = dns.name.from_text('ip6.arpa.')

def from_address(text):
    
    try:
        parts = list(dns.ipv6.inet_aton(text).encode('hex_codec'))
        origin = ipv6_reverse_domain
    except:
        parts = [ '%d' % ord(byte) for byte in dns.ipv4.inet_aton(text) ]
        origin = ipv4_reverse_domain

    parts.reverse()
    return dns.name.from_text('.'.join(parts), origin = origin)


def to_address(name):
    if name.is_subdomain(ipv4_reverse_domain):
        name = name.relativize(ipv4_reverse_domain)
        labels = list(name.labels)
        labels.reverse()
        text = '.'.join(labels)
        return dns.ipv4.inet_ntoa(dns.ipv4.inet_aton(text))
    elif name.is_subdomain(ipv6_reverse_domain):
        name = name.relativize(ipv6_reverse_domain)
        labels = list(name.labels)
        labels.reverse()
        parts = []
        i = 0
        l = len(labels)
        while i < l:
            parts.append(''.join(labels[i:i + 4]))
            i += 4
        text = ':'.join(parts)
        return dns.ipv6.inet_ntoa(dns.ipv6.inet_aton(text))
    else:
        raise dns.exception.SyntaxError, 'unknown reverse-map address family'

